---
title: RTCPeerConnection.getStreamById()
slug: Web/API/RTCPeerConnection/getStreamById
tags:
  - Experimental
  - Method
  - RTCPeerConnection
  - Reference
  - WebRTC
---
<p>{{APIRef}}{{SeeCompatTable}}</p>

<p>{{obsolete_header()}}</p>

<p>The <code><strong>RTCPeerConnection.getStreamById()</strong></code> method returns the <a href="/en-US/docs/Web/API/MediaStream" title="The MediaStream interface represents a stream of media content. A stream consists of several tracks, like video or audio tracks."><code>MediaStream</code></a> with the given id that is associated with local or remote end of the connection. If no stream matches, it returns <code>null</code>.</p>

<div class="warning">
<p>This property has been replaced with the {{domxref("RTCPeerConnection.getLocalStreams")}} and {{domxref("RTCPeerConnection.getRemoteStreams")}} properties. If you have code that uses <code>stream</code>, you will need to update, since browsers have begun to remove support for <code>stream</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><code>var<em> mediaStream</em> = <em>pc</em>.getStream(id);
</code></pre>

<h3 id="Example">Parameters</h3>

<dl>
 <dt><em>id</em></dt>
 <dd>Is a {{domxref("DOMString")}} corresponding to the stream to return.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var stream = pc.getStreamById(myTrackId);
if (stream) {
  console.log("Found stream: " + stream.id);
}</pre>

<h2 id="Polyfill">Polyfill</h2>

<p>Running the following code before any other code will create <code>RTCPeerConnection.prototype.getStreamById()</code> if it's not natively available.</p>

<pre class="brush: js">// from: https://bugs.chromium.org/p/chromium/issues/detail?id=698163&amp;desc=5#c10
RTCPeerConnection.prototype.getStreamById = function(id) {
  try {
    var localStreams = this.getLocalStreams();
    var remoteStreams = this.getRemoteStreams();
    var i;
    for (i = 0; i &lt; localStreams.length; i++) {
     if (localStreams[i].id == id)
       return localStreams[i];
    }
    for (i = 0; i &lt; remoteStreams.length; i++) {
     if (remoteStreams[i].id == id)
       return remoteStreams[i];
    }
  } catch(e) {}
  return null;
}
</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.getStreamById")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/WebRTC">WebRTC</a></li>
</ul>
